/*                      LEKCJA06.C
//---------------------------------------------------------------------------
Temat:
        Definiowanie elementu POLILINIA
//---------------------------------------------------------------------------
Funkcja:
        EXT(215) ushort AddPolylnPt(   
//---------------------------------------------------------------------------

   Polilinia (albo kontur) jest cigiem zdefiniowanym z linii i/lub ukw.
   Jedna polilinia moe si skada maksymalnie z 1300 elementw.


typedef struct _polyln
{
    ushort   num;        // Ilo zdefiniowanych punktw
    t_polypt _far *ppt;  // Tablica opisujca punkty
} t_polyln;

typedef struct _polypt
{
    double mpd;          // strzaka wygicia uku 
    double px;           // wsprzdna X punktu
    double py;           // wsprzdna Y punktu
} t_polypt;


   Aby uatwi doczenie nowego elementu do polilinii zdefiniowano funkcj:
   
EXT(215) ushort AddPolylnPt(   
             t_polyln *polyln, // Struktura polilinii
             double   *mpd,    // strzaka wygicia uku
             double   px,      // wsprzdna X punktu
             double   py);     // wsprzdna Y punktu


 Zmienna strzaki ugicia moe przyjmowa nastpujce wartoci:

        mpd = NULL    : cz niewidoczna
        mpd = 0       : cz prosta = odcinek
        mpd!= 0       : cz bdca ukiem o strzace ugicia = 'mpd'
                              warto dodatnia jest ugiciem 'w prawo',
                              a ujemna 'w lewo'.

Return:
    FALSE => jeli przekroczono maksymaln ilo punktw
    TRUE  => prawidowe dziaanie


*/
//---------------------------------------------------------------------------
//  program zamienia wykres funkcji kwadratowej [y= a*x+b*x+c] na polilinie 
//
// Andrzej Setman                                           Wieden 13.08.95
//---------------------------------------------------------------------------
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
#define   KROK        200 
//---------------------------------------------------------------------------
short main(char *filename, char *args)
{
   t_polygon gon;
   t_polyln  kontur;  
   t_polypt  polypt[KROK+1]; 

   double wyb, kier;                         // warto i kier. wyboczenia  
   double xmax= 100.0, xmin= -100;           // liczony przedzia
   double a= 0.01, b= 0, c= 20;              // parametry paraboli
   double x, y, x0, y0, xe, ys;
   double delta;                             // interwa
   double r;                                 // strzaka wyboczenia
   short  f;

   kier= a>0 ? -1 : 0;                       // kierunek ugiecia luku
   delta= (xmax-xmin) / KROK;                
   r= kier*(0.5*(a*delta*delta+b*delta)-(0.25*a*delta*delta+0.5*b*delta));

   kontur.ppt= polypt;                       // inicjalizacja konturu
   kontur.num= 0;

   for (f=0 ; f<=KROK ; f++)
   {
      x= xmin + f * delta;
      xe= x - delta/2;
      y= a*x*x + b*x +c;
      wyb= f>0 ? r : 0;
      x0= x;
      y0= y;
      AddPolylnPt(&kontur,&wyb,x,y);
   }
   CreateEntity(E_POLYLN,NULL,&kontur); 
   savecount(); 
   return(0);
}
//------------------------------KONIEC---------------------------------------
